//=============================================================================
// RPG Maker MZ - Add Choice Item Help
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Add help window into choice item.
 * @author Evilcat
 */

(() => {
    const _Scene_Message_createAllWindows = Scene_Message.prototype.createAllWindows;
    Scene_Message.prototype.createAllWindows = function() {
        _Scene_Message_createAllWindows.call(this);
        this.createEventHelpWindow();
    };

    Scene_Message.prototype.eventItemWindowRect = function() {
    	const wx = 900;
    	const wy = 150;
    	const ww = 500;
    	const wh = 300;
    	return new Rectangle(wx, wy, ww, wh);
    };

    Scene_Message.prototype.createEventHelpWindow = function() {
	const rect = this.eventHelpWindowRect();
        this._eventHelpWindow = new Window_Help(rect);
        this.addWindow(this._eventHelpWindow);
        this._eventHelpWindow.hide();
    };

    Scene_Message.prototype.eventHelpWindowRect = function() {
    	const wx = 900;
    	const wy = 450;
    	const ww = 500;
    	const wh = this.calcWindowHeight(1, true);
    	return new Rectangle(wx, wy, ww, wh);
    };

    const _Scene_Message_start = Scene_Message.prototype.start;
    Scene_Message.prototype.start = function() {
        _Scene_Message_start.call(this);
        this._eventItemWindow.setHelpWindow(this._eventHelpWindow);
    };

    Window_EventItem.prototype.start = function() {
    	this.refresh();
    	this.updatePlacement();
    	this.placeCancelButton();
    	this.forceSelect(0);
    	this.open();
    	this._helpWindow.show();
    	this.activate();
    };

    const _Window_EventItem_updateHelp = Window_EventItem.prototype.updateHelp;
    Window_EventItem.prototype.updateHelp = function() {
        if (this._helpWindow) {
            this._helpWindow.setText(this.item() ? this.item().description : '');
        }
    };

    Window_EventItem.prototype.close = function() {
        Window_Base.prototype.close.call(this);
	this._helpWindow.hide();
    };

    Window_EventItem.prototype.updatePlacement = function() {
    	;
    };

})();