//=============================================================================
// RPG Maker MZ - Custom Game Audio
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Custom Game Audio
 * @author Evilcat
 */

const circleVoice = name => {
    	let audio = {};
    	audio.name = name;
    	audio.pitch = 125;
    	audio.volume = 200;
    	audio.pan = 0;
    	return audio;
};

const characterVoice = name => {
    	let audio = {};
    	audio.name = name;
    	audio.pitch = 105;
    	audio.volume = 200;
    	audio.pan = 0;
    	return audio;
};

const createRainBgs = name => {
    	let audio = {};
    	audio.name = name;
    	audio.pitch = 80;
    	audio.volume = 40;
    	audio.pan = 0;
    	return audio;
};

(() => {

    AudioManager.playBgm = function(bgm, pos) {
    	if (this.isCurrentBgm(bgm)) {
        	this.updateBgmParameters(bgm);
    	} else {
        	this.stopBgm();
        	if (bgm.name) {
            	    this._bgmBuffer = this.createBuffer("bgm/", bgm.name);
            	    this.updateBgmParameters(bgm);
            	    this._bgmBuffer.play(true, pos || 0); 
        	}
    	}
    	this.updateCurrentBgm(bgm, pos);
    };

    AudioManager.playMe = function(me) {
      if (me.name && !this._meBuffer) {
      	this._meBuffer = this.createBuffer("me/", me.name);
	
	if(!this._meBuffer.isPlaying()){
          this.updateMeParameters(me);
          this._meBuffer.play(false);
          this._meBuffer.addStopListener(this.stopMe.bind(this));
        }
      }
    };

    AudioManager.stopMe = function() {
      if (this._meBuffer) {
        this._meBuffer.destroy();
        this._meBuffer = null;
      }
    };

    AudioManager.updateBufferParameters = function(buffer, configVolume, audio) {
    	if (buffer && audio) {
	    if(audio.volume==100)audio.volume=200;
            buffer.volume = (configVolume * (audio.volume || 0)) / 10000;
            buffer.pitch = (audio.pitch || 0) / 100;
            buffer.pan = (audio.pan || 0) / 100;
    	}
    };

})();
