//=============================================================================
// RPG Maker MZ - Custom conversation
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Custom conversation bg.
 * @author Evilcat
 */

(() => {

    Window.prototype._createPauseSignSprites = function() {
	this._pauseSignSprite = new Sprite();
    };

    Scene_Message.prototype.messageWindowRect = function() {
    	const ww = 730;
    	const wh = 216;
    	const wx = 0;
    	const wy = 0;
    	return new Rectangle(wx, wy, ww, wh);
    };

    Window_Message.prototype.resetTextColor = function() {
    	if(this._positionType==2){
	    this.changeTextColor(ColorManager.menuOutlineColor());
    	    this.changeOutlineColor(ColorManager.systemColor());
	}else{
	    this.changeTextColor(ColorManager.normalColor());
	    this.changeOutlineColor(ColorManager.menuOutlineColor());
	}
	this.contents.outlineWidth = 4;
    };

    Window_Message.prototype.startMessage = function() {
    	const text = $gameMessage.allText();
	this._tname = $gameMessage.speakerName();
	this._positionType = $gameMessage.positionType();
	this._faceIndex =  $gameMessage.faceIndex();
	this._margin = 0;
	this._padding = 0;

	if(this._positionType==2)this.manualMessage();
	else this.mailMessage();

    	const textState = this.createTextState(text, 0, 0, 0);
    	this._textState = textState;
    	this.newPage(this._textState);
    	this.updateBackground();
    	this.open();
	if(this._positionType!=2)this._nameBoxWindow.start();
    };

    Window_Message.prototype.manualMessage = function() {
	const posvars = this._tname.split(',');
	this.x = (posvars[0]?parseInt(posvars[0]):0);
	this.y = (posvars[1]?parseInt(posvars[1]):0);
    };

    Window_Message.prototype.mailMessage = function() {
	this.x = (Graphics.boxWidth - this.width) / 2;
	this.y = (Graphics.boxHeight - this.height) / 2;
    };

    Window_Message.prototype.drawMessageFace = function() {
    	const rtl = $gameMessage.isRTL();
    	const h1 = 192*(this._faceIndex/4);
    	const h2 = 192*((this._faceIndex/4)+1);
        this.contents.blt(this._faceBitmap, 0, h1, 706, h2, 0, 0);
    };

    Window_Message.prototype.newPage = function(textState) {
    	this.contents.clear();
    	this.resetFontSettings();
    	this.clearFlags();
	if(this._positionType==2){
	    this._nameBoxWindow.visible = false;
    	    this.loadMessageFace();
    	    textState.x = this.newLineX();
	    textState.startX = textState.x;
    	    textState.y = this.newLineY();
    	    textState.height = this.calcTextHeight(textState);
	}else{
	    if(this._positionType==0)this._nameBoxWindow.visible = true;
	    else this._nameBoxWindow.visible = false;
	    this.updateSpeakerName();
    	    textState.x = 20;
	    textState.startX = textState.x;
    	    textState.y = 20;
    	    textState.height = this.calcTextHeight(textState);
	}
    };

    Window_Message.prototype.newLineX = function() {
	let startX = 10;
    	if(this._faceIndex==0)startX = 430;
	else if(this._faceIndex==4)startX = 240;
    	return startX;
    };

    Window_Message.prototype.newLineY = function() {
    	return (this._faceIndex==8 || this._faceIndex==20)?12:56;
    };

    Window_Message.prototype.updateSpeakerName = function() {
    	this._nameBoxWindow.setName("メール送信者 : "+this._tname);
    };

    Window_NameBox.prototype.windowWidth = function() {
    	return 730;
    };

})();