//=============================================================================
// RPG Maker MZ - Custom Game Core Function
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Custom Game Core Function
 * @author Evilcat
 *
 * @command TimeChange
 * @text TimeChange
 * @desc Set Time Change parameter.
 * 
 * @command DayChange
 * @text DayChange
 * @desc Set Day Change parameter.
 */

let updateLove = false;
let updateMail = false;

function addVarValue(index,value){
    $gameVariables.setValue(index,value+$gameVariables.value(index));
}

function loveUP(value){
    const clove = $gameVariables.value(3);
    const love = $gameVariables.value(3) + value;
    if(love<=35){
    	$gameVariables.setValue(3,love);
    }else if(love<=70){
	if($gameSwitches.value(16))$gameVariables.setValue(3,love);
	else $gameVariables.setValue(3,35);
    }else if(love<=100){
	if($gameSwitches.value(11))$gameVariables.setValue(3,love);
	else $gameVariables.setValue(3,70);
    }else{
    	$gameVariables.setValue(3,100);
    }
    if(clove != $gameVariables.value(3)){
    	$gameTemp.requestAnimation([$gamePlayer],1);
    	updateLove = true;
    }
}

function inviteCheck(){
    const love = $gameVariables.value(3);
    if(love<10){
	return false;
    }else if(love<20){
	if(Math.floor(Math.random()*3)==0)return true;
	else return false;
    }else if(love<35){
	if(Math.floor(Math.random()*3)==0)return false;
	else return true;
    }else{
	return true;
    }
}

function birthdayCheck(){
    if($gameVariables.value(1)==6 && $gameParty.hasItem($dataItems[3],false)){
	return true;
    }else{
	return false;
    }
}

(() => {

    ColorManager.normalColor = function() {
    	return this.textColor(6);
    };

    ColorManager.systemColor = function() {
    	return this.textColor(0);
    };

    ColorManager.menuOutlineColor = function() {
    	return this.textColor(2);
    };

    Game_System.prototype.menuFontFace = function() {
	return "rmmz-menufont";
    };

    Game_Switches.prototype.setValue = function(switchId, value) {
    	if (switchId > 0 && switchId < $dataSystem.switches.length) {
            this._data[switchId] = value;
            this.onChange();
    	}
	if(switchId==3)updateMail=true;
    };

    SceneManager.isGameActive = function () { return true; };

    Scene_Boot.prototype.loadGameFonts = function() {
    	const advanced = $dataSystem.advanced;
    	FontManager.load("rmmz-mainfont", advanced.mainFontFilename);
    	FontManager.load("rmmz-numberfont", advanced.numberFontFilename);
	FontManager.load("rmmz-menufont", "infroman.woff");
    };

    Scene_Load.prototype.onLoadSuccess = function() {
	$gamePlayer._moveSpeed = ConfigManager.playerSpeed;
    	SoundManager.playLoad();
    	this.fadeOutAll();
    	this.reloadMapIfUpdated();
    	SceneManager.goto(Scene_Map);
    	this._loadSuccess = true;
    };

    Window_ChoiceList.prototype.windowY = function() {
	return Graphics.boxHeight / 2;
    };

    Window_ChoiceList.prototype.maxLines = function() {
    	const messageWindow = this._messageWindow;
    	const messageY = messageWindow ? messageWindow.y : 0;
    	const messageHeight = messageWindow ? messageWindow.height : 0;
    	const centerY = Graphics.boxHeight / 2;
    	if (messageY < centerY && messageY + messageHeight > centerY) {
            return 6;
    	} else {
            return 8;
    	}
    };

    Window_ChoiceList.prototype.windowX = function() {
    	const positionType = $gameMessage.choicePositionType();
    	if (positionType === 1) {
            return (Graphics.boxWidth - this.windowWidth()) / 2 + 150;
    	} else if (positionType === 2) {
            return Graphics.boxWidth - this.windowWidth() - 50;
    	} else {
            return 140;
    	}
    };

    Window_ChoiceList.prototype.windowY = function() {
	return (7-$gameMessage._choices.length)*50;
    };

    Sprite_Animation.prototype.targetPosition = function(renderer) {
    	const pos = new Point();
    	if (this._animation.displayType === 2) {
            pos.x = 40;
            pos.y = 40;
    	} else {
            for (const target of this._targets) {
            	const tpos = this.targetSpritePosition(target);
            	pos.x += tpos.x;
            	pos.y += tpos.y;
            }
            pos.x /= this._targets.length;
            pos.y /= this._targets.length;
    	}      
    	return pos;
    };

    PluginManager.registerCommand("CustomCore", "TimeChange", args => {
	//set npc postion
	setMahiruPosition();
	setNpcPosition();
	delSomeEmail();
    });

    PluginManager.registerCommand("CustomCore", "DayChange", args => {
	addVarValue(1,1);
	if($gameVariables.value(1)>28)$gameVariables.setValue(1,1);
	$gameVariables.setValue(2,0);
	$gameSwitches.setValue(7,false);
	$gameSwitches.setValue(8,false);
	const day7 = $gameVariables.value(1)%7;
	//set weekend
	$gameSwitches.setValue(1,(day7==0 || day7==6));
	//random rain
	$gameSwitches.setValue(2,(Math.floor(Math.random()*3)==0));
	//set day event
	setDayEvent();
	//set npc postion
	setMahiruPosition();
	setNpcPosition();
	delSomeEmail();
	sendDayEmail();
    });

    function setDayEvent(){
	let rand = 1;
	if($gameVariables.value(1)>2)rand = Math.floor(Math.random()*3);

	//Day event 3=legs 4=moba 7=mmother
	//Event 3-4 only on weekday
	if(!$gameSwitches.value(14) && rand==0){
	    if(!$gameSwitches.value(1) && !$gameSwitches.value(2))$gameVariables.setValue(8,3);
	}else if($gameSwitches.value(14) && !$gameSwitches.value(15) && rand==0){
	    if(!$gameSwitches.value(1) && !$gameSwitches.value(2))$gameVariables.setValue(8,4);
	}else if($gameSwitches.value(11) && !$gameSwitches.value(17) && $gameSwitches.value(1)){
	    $gameVariables.setValue(8,7);
	}else{
	    $gameVariables.setValue(8,0);
	}
    }

    function setMahiruPosition(){
	const ctime = $gameVariables.value(2);
	const rand = Math.floor(Math.random()*7);
	//Set Mahiru pos if not event day
	if($gameVariables.value(8)==0){
	    //Day mahiru on but not cohabitation
	    if($gameSwitches.value(7)){
		//Invite or not
	    	if($gameSwitches.value(8)){
	    	    $gameVariables.setValue(9,2);
	    	}else{
	    	    $gameVariables.setValue(9,0);
	    	}
	    }else{
	    	//cohabitation or not
	    	if($gameSwitches.value(11)){
		    //weekend or not
		    if($gameSwitches.value(1)){
			if(rand<2){
			    $gameVariables.setValue(9,7);
			}else{
			    $gameVariables.setValue(9,2);
			}
		    }else{
			if(ctime==0){
			    $gameVariables.setValue(9,0);
			}else{
			    if(rand<2){
				$gameVariables.setValue(9,7);
			    }else{
				$gameVariables.setValue(9,2);
			    }
			}
		    }
	    	}else{
		    //weekend or not
		    if($gameSwitches.value(1)){
			//rain or not
			if($gameSwitches.value(2)){
			    $gameVariables.setValue(9,1);
			}else{
			    if(ctime==2){
			    	$gameVariables.setValue(9,1);
			    }else{
			    	if(rand<2){
				    $gameVariables.setValue(9,5);
			    	}else{
				    $gameVariables.setValue(9,1);
			    	}
			    }
			}
		    }else{
			if($gameSwitches.value(2)){
			    //check time when rain
			    if(ctime==0){
				$gameVariables.setValue(9,0);
			    }else if(ctime==1){
				if(rand==0)$gameVariables.setValue(9,0);
				else if(rand<3)$gameVariables.setValue(9,5);
				else $gameVariables.setValue(9,1);
			    }else{
				if(rand==0)$gameVariables.setValue(9,0);
				else if(rand==1)$gameVariables.setValue(9,5);
				else $gameVariables.setValue(9,1);
			    }
		    	}else{
			    //check time when not rain
			    if(ctime==0){
				$gameVariables.setValue(9,0);
			    }else if(ctime==1){
				if(rand==0)$gameVariables.setValue(9,0);
				else if(rand<3)$gameVariables.setValue(9,3);
				else if(rand<5)$gameVariables.setValue(9,5);
				else $gameVariables.setValue(9,1);
			    }else{
				if(rand==0)$gameVariables.setValue(9,3);
				else if(rand==1)$gameVariables.setValue(9,5);
				else $gameVariables.setValue(9,1);
			    }
		    	}
		    }
	    	}
	    }
	}else{
	    $gameVariables.setValue(9,0);
	}
    }
	
    function setNpcPosition(){
	const rand = Math.floor(Math.random()*5);
	if($gameSwitches.value(2)){
	    if(rand<2)$gameVariables.setValue(10,1);
	    else $gameVariables.setValue(10,0);
	}else{
	    if(rand==0)$gameVariables.setValue(10,1);
	    else if(rand==1)$gameVariables.setValue(10,2);
	    else $gameVariables.setValue(10,0);
	}
    }

    function sendDayEmail(){
	const rand = Math.floor(Math.random()*3);
	const cday = $gameVariables.value(1);
	if(cday==4 && !$gameSwitches.value(16)){
	    $gameVariables.setValue(5,2);
	    $gameSwitches.setValue(3,true);
	}else if(cday%14==0 && $gameVariables.value(5)<5){
	    $gameVariables.setValue(5,3);
	    $gameSwitches.setValue(3,true);
	}else if($gameSwitches.value(11) && !$gameSwitches.value(1) && rand==0){
	    $gameVariables.setValue(5,7);
	    $gameSwitches.setValue(3,true);
	}
	//Del MNP store mail if not open in 14th28th day
	if($gameVariables.value(5)==3 && (cday==15 || cday==1)){
	    $gameVariables.setValue(5,0);
	    $gameSwitches.setValue(3,false);
	}
    }

    function delSomeEmail(){
	//Del Mahiru mail if not open in the morning
	if($gameVariables.value(5)==7){
	    $gameVariables.setValue(5,0);
	    $gameSwitches.setValue(3,false);
	}
    }

})();